; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include Project.inc        ; local includes for this file

.code

start:

; 

      invoke InitCommonControls

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   rv(GetModuleHandle, NULL)
      mov CommandLine, rv(GetCommandLine)
      mov hIcon,       rv(LoadIcon,hInstance,500)
      mov hCursor,     rv(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        rv(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        rv(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"ProStart_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

    mov Wwd, 300
    mov Wht, 300
    invoke TopXY,Wwd,sWid
    mov Wtx, eax
    invoke TopXY,Wht,sHgt
    mov Wty, eax

    invoke CreateWindowEx,WS_EX_LEFT or WS_EX_ACCEPTFILES,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax
    
 invoke InitD3D
 invoke InitGeometry
  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayMenu hWnd,600
    DisplayWindow hWnd,SW_SHOWDEFAULT
    invoke UpdateWindow, hWnd

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret
RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
        
    .while msg.message!=WM_QUIT
        invoke PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE
        .if eax != 0
            invoke GetMessage,esi,edi,edi,edi
            invoke TranslateMessage, esi
            ; --------------------------------------
            ; perform any required key processing here
            ; --------------------------------------
            invoke DispatchMessage, esi
            xor eax,eax
            invoke Render
        .else
            invoke Render
        .endif
    .endw

    invoke Cleanup
    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

        Switch wParam
        ;======== menu commands ========

          Case 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900

          ;====== end menu commands ======
      Endsw

      Case WM_CREATE
        invoke Do_Status,hWin
     Case WM_SYSCOLORCHANGE

      Case WM_SIZE
        invoke MoveWindow,hStatus,0,0,0,0,TRUE

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp


; 


; 

InitD3D proc


     LOCAL d3dpp :D3DPRESENT_PARAMETERS
     
push   ebp
mov    ebp,esp
sub    esp,104


    ; Create the D3D object, which is needed to create the D3DDevice.
    INVOKE Direct3DCreate9,D3D_SDK_VERSION

    .if eax==0
        leave           ;If the process fails we better stop here
        ret    
    .endif
    
    mov g_pD3D,eax

    ;Set up the structure used to create the D3DDevice. Most parameters are
    ;zeroed out. We set Windowed to TRUE, since we want to do D3D in a
    ;window, and then set the SwapEffect to "discard", which is the most
    ;efficient method of presenting the back buffer to the display.  And 
    ;we request a back buffer format that matches the current desktop display 
    ;format.

    invoke memfill, ADDR d3dpp, sizeof d3dpp, 0h
    mov d3dpp.Windowed, TRUE
    mov d3dpp.SwapEffect, 1
    mov d3dpp.BackBufferFormat,0

    ;Create the Direct3D device. Here we are using the default adapter (most
    ;systems only have one, unless they have multiple graphics hardware cards
    ;installed) and requesting the HAL (which is saying we want the hardware
    ;device rather than a software one). Software vertex processing is 
    ;specified since we know it will work on all cards. On cards that support 
    ;hardware vertex processing, though, we would see a big performance gain 
    ;by specifying hardware vertex processing.


    IDirect3D9_CreateDevice g_pD3D, D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, d3dpp,  g_pd3dDevice


    ;Turn off culling, so we see the front and back of the triangle
    IDirect3DDevice9_SetRenderState g_pd3dDevice, D3DRS_CULLMODE, D3DCULL_NONE 

    ;Turn off D3D lighting, since we are providing our own vertex colors
    IDirect3DDevice9_SetRenderState g_pd3dDevice, D3DRS_LIGHTING, FALSE 

    xor  eax,eax
    leave  
    ret    
    
InitD3D endp


; 


Cleanup proc


        push   ebp
        mov    ebp,esp
        sub    esp,8

        .if g_pVB != NULL 
            IDirect3DVertexBuffer9_Release g_pVB
        .endif

        .if g_pd3dDevice != NULL
            IDirect3DDevice9_Release g_pd3dDevice
        .endif
        
        .if g_pD3D != NULL
            IDirect3D9_Release g_pD3D
        .endif
        leave  
        ret    

Cleanup endp

; 

;-----------------------------------------------------------------------------
; Name: Render()
; Desc: Draws the scene
;-----------------------------------------------------------------------------
Render proc

    push ebp
    mov ebp,esp
    sub esp,40
    
    .if  g_pd3dDevice != NULL
    
            ; Clear the backbuffer to black
            IDirect3DDevice9_Clear g_pd3dDevice, 0, NULL, D3DCLEAR_TARGET, 0, 3f800000h, 0 
       
            IDirect3DDevice9_BeginScene g_pd3dDevice
            ;Setup the world, view, and projection matrices
            INVOKE SetupMatrices
    
            ;Draw the triangles in the vertex buffer. This is broken into a few
            ;steps. We are passing the vertices down a "stream", so first we need
            ;to specify the source of that stream, which is our vertex buffer. Then
            ;we need to let D3D know what vertex shader to use. Full, custom vertex
            ;shaders are an advanced topic, but in most cases the vertex shader is
            ;just the FVF, so that D3D knows what type of vertices we are dealing
            ;with. Finally, we call DrawPrimitive() which does the actual rendering
            ;of our geometry (in this case, just one triangle).

            IDirect3DDevice9_SetStreamSource g_pd3dDevice, 0, g_pVB, 0, sizeof(CUSTOMVERTEX)
            IDirect3DDevice9_SetFVF g_pd3dDevice, D3DFVF_CUSTOMVERTEX
            IDirect3DDevice9_DrawPrimitive g_pd3dDevice, D3DPT_TRIANGLESTRIP, 0, 1 
            
            .if eax == 0
                ; End the scene
                IDirect3DDevice9_EndScene g_pd3dDevice
            .endif
           
        ; Present the backbuffer contents to the display
        IDirect3DDevice9_Present  g_pd3dDevice, NULL, NULL, NULL, NULL
    .endif
    leave
    ret
    
Render endp

; 
; Name: InitGeometry()
; Desc: Creates the scene geometry
; 

InitGeometry proc

    
    push ebp
    mov ebp,esp
    sub esp,100h
    
    ;Create the vertex buffer. Here we are allocating enough memory
    ;(from the default pool) to hold all our 3 custom vertices. We also
    ;specify the FVF, so the vertex buffer knows what data it contains.

    xor eax,eax
    
    IDirect3DDevice9_CreateVertexBuffer  g_pd3dDevice, 3*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, g_pVB, NULL
    .if g_pVB !=0
        ;Now we fill the vertex buffer. To do this, we need to Lock() the VB to
        ;gain access to the vertices. This mechanism is required becuase vertex
        ;buffers may be in device memory.
        
        IDirect3DVertexBuffer9_Lock g_pVB, 0, sVertices, pVertices, 0 

        .if eax ==0
            INVOKE MemCopy, addr Vertices, pVertices, sVertices
            IDirect3DVertexBuffer9_Unlock g_pVB
        .endif
    .else 
        mov eax,1
    .endif
    leave
    ret
    
InitGeometry endp


; 
;Name: SetupMatrices()
;Desc: Sets up the world, view, and projection transform matrices.
; 
SetupMatrices proc

    push ebp
    mov ebp,esp
    sub esp,24
    
    ;Set up the rotation matrix to generate 1 full rotation (2*PI radians) 
    ;every 1000 ms. To avoid the loss of precision inherent in very high 
    ;floating point numbers, the system time is modulated by the rotation 
    ;period before conversion to a radian angle.

    INVOKE GetLocalTime, ADDR SysTime 


    xor eax,eax
    mov ax, SysTime.wMilliseconds  ;Time is a word so we have to do a conversion
    mov tempa,eax

;Quick and dirty calculation to animaniate the thing

    fild tempa
    fmul tempb
    fst fAngle
    fwait
    
    

    INVOKE D3DXMatrixRotationY, ADDR matWorld, fAngle
    IDirect3DDevice9_SetTransform g_pd3dDevice, 100h, matWorld

    ;Set up our view matrix. A view matrix can be defined given an eye point,
    ;a point to lookat, and a direction for which way is up. Here, we set the
    ;eye five units back along the z-axis and up three units, look at the
    ;origin, and define "up" to be in the y-direction.
    
    INVOKE D3DXMatrixLookAtLH, ADDR matView, ADDR vEyePt,ADDR vLookatPt, ADDR vUpVec
    IDirect3DDevice9_SetTransform g_pd3dDevice, D3DTS_VIEW, matView

    ;For the projection matrix, we set up a perspective transform (which
    ;transforms geometry from 3D view space to 2D viewport space, with
    ;a perspective divide making objects smaller in the distance). To build
    ;a perpsective transform, we need the field of view (1/4 pi is common),
    ;the aspect ratio, and the near and far clipping planes (which define at
    ;what distances geometry should be no longer be rendered).

    INVOKE D3DXMatrixPerspectiveFovLH, ADDR matProj, 3F490FDBh, 3F800000h, 3F800000h, 42C80000h
    IDirect3DDevice9_SetTransform g_pd3dDevice, D3DTS_PROJECTION, matProj
    leave
    ret

SetupMatrices endp



OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 


end start
